doodleJump={}


function doodleJump.init()
	plataforms={}

	player={}
	player.x=20
	player.y=sizeY*10+20
	player.speed=-9
	player.graphics=love.graphics.newImage("tux.png")

	plat={}
	plat.graphics=love.graphics.newImage("plat.png")
	plat.sx=50
	plat.sy=20

	score=0

	background=love.graphics.newImage("background.png")
	jumpSound=love.audio.newSource("pulo.wav","static")

	doodleJump.initPlataforms(5)
end

function doodleJump.draw()
	
	local x,y=topCam:toWorld(0,0)
	--printC(x.." "..y)

	love.graphics.draw(background,x,y,0,1,1.5)

	love.graphics.print("remaining plataforms:"..#plataforms,x,y)
	
	for _,v in ipairs(plataforms) do
	  	love.graphics.draw(plat.graphics,v.x,v.y-v.sy/2,0)
	end
	
	love.graphics.draw(player.graphics,player.x-player.graphics:getWidth()/2,player.y-player.graphics:getHeight()/2,0)
end

function doodleJump.initPlataforms(n)
	local _,_,_,worldsizeY=topCam:getWorld()
	printC(worldsizeY)
	for count=n,1,-1 do
		table.insert(plataforms,{x=math.random(1,love.graphics.getWidth()/2-50),
			y=love.graphics.getHeight()/5*count+worldsizeY-love.graphics.getHeight(),
			sx=plat.sx,sy=plat.sy})
	end
	--printC(#plataforms)
end

local function highest()
	if #plataforms==0 then
		return player.y-100
	else
		return plataforms[#plataforms].y-100
	end
end
function doodleJump.update(dt)
	player.speed=player.speed+7*dt

	for i,v in ipairs(plataforms) do
		if between(player.x,v.x,v.x+v.sx) and between(player.y,v.y,v.y+v.sy) and player.speed>=0 then
			player.speed=-9
			table.remove(plataforms,1)
			--table.insert(plataforms,{x=math.random(1,love.graphics.getWidth()/2-50),y=highest(),sx=plat.sx,sy=plat.sy})

			love.audio.stop(jumpSound)
			love.audio.play(jumpSound)
		end
	end

	player.y=player.y+player.speed

	if #plataforms~=0 and  not between(player.x,plataforms[1].x+10,plataforms[1].x+plataforms[1].sx-20) then
		if player.x>plataforms[1].x+plataforms[1].sx-20 then
			player.x=player.x-300*dt
		else
			player.x=player.x+300*dt
		end
	end


	topCam:setPosition(player.x,player.y-200)

	if #plataforms==0 then -- and   
		gameover=true
	else
		if (player.y>plataforms[1].y+100 and player.speed>0) then
			gameover=true
		end
	end
end

function doodleJump.keypressed()

	end

function doodleJump.reward(n)
	printC("rewarded")
	for x=#plataforms,#plataforms+n-1 do
		plataforms[x+1]={x=math.random(1,love.graphics.getWidth()/2-50),y=highest(),sx=plat.sx,sy=plat.sy}
	end
	score=score+10
end

function doodleJump.punish(n)
	for x=1,n do
		table.remove(plataforms,#plataforms)
	end
end


return doodleJump