geometricPuzzle={}
function geometricPuzzle.init(n)
	radius=30
	number=n
	done=0
	maxverts=10
	shapes={}


	for count=1,number do
		vert=math.random(3,maxverts)
		for _,v in ipairs(shapes) do
			while v.verts==vert do
				vert=math.random(3,maxverts)
			end
		end
		table.insert(shapes,{
			xholder=sizeX/2+radius,
			yholder=count*100,
			xshape=math.random(sizeX/2+50,sizeX),
			yshape=math.random(0,sizeY),
			color={math.random(1,255),math.random(1,255),math.random(1,255)},
			verts=vert,
			rot=math.random(0,2*math.pi)
		})
	end

	combined=love.audio.newSource("correct.wav","static")
	background2=love.graphics.newImage("background2.png")
end

function geometricPuzzle.draw()
	love.graphics.print("remaining shapes: "..number,sizeX/2+10,sizeY)
	love.graphics.draw(background2,sizeX/2,0,0)

	for _,v in ipairs(shapes) do
		love.graphics.setColor(255,255,255)
		love.graphics.circle("line",v.xholder,v.yholder,radius,v.verts)
		love.graphics.setColor(v.color)
		love.graphics.circle("fill",v.xshape,v.yshape,radius-2,v.verts)
	end
	love.graphics.setColor(255,255,255)
end

function geometricPuzzle.mousepressed(x,y,button)

	for _,v in ipairs(shapes) do
		if between(love.mouse.getX(),v.xshape-radius,v.xshape+radius) and between(love.mouse.getY(),v.yshape-radius,v.yshape+radius) then
			dragged=v
		end
	end
end

function geometricPuzzle.mousereleased(x,y,button)
	if dragged~=nil and  between(dragged.xshape,dragged.xholder-radius,dragged.xholder+radius) and between(dragged.yshape,dragged.yholder-radius,dragged.yholder+radius)then
		love.audio.stop(combined)
		love.audio.play(combined)
		dragged.xshape,dragged.yshape=dragged.xholder,dragged.yholder
		done=done+1
		if done==number then
			reward(number)
			geometricPuzzle.init(number+1)
		end
	end
	dragged=nil

end

function geometricPuzzle.update(dt)
	if dragged ~= nil then
		dragged.xshape=love.mouse.getX()
		dragged.yshape=love.mouse.getY()
	end

end

return geometricPuzzle