otherGeometricPuzzle={}


function otherGeometricPuzzle.init(n)
	radius=30
	dist=200
	number=math.floor(n)
	aux=n
	done=0
	maxverts=6
	shapes={}


	for count=math.pi/10,2*math.pi,1.75*math.pi/number do
		vert=math.random(3,maxverts)
		table.insert(shapes,{
			xholder=math.sin(count)*dist+sizeX*0.75,
			yholder=math.cos(count)*dist+sizeY/2,
			color={math.random(20,255),math.random(20,255),math.random(20,255)},
			verts=vert,
		})
	end


	central={}
	central.x=sizeX*0.75
	central.y=sizeY/2
	vert=math.random(3,maxverts)
	central.verts=vert
	for _,v in ipairs(shapes) do
		while v.verts==vert do
			v.verts=math.random(3,maxverts)
		end
	end
	shapes[math.random(1,#shapes)].verts=vert



	love.mouse.setPosition(central.x,central.y)
	love.mouse.setVisible(false)

	combinedSound=love.audio.newSource("correct.wav","static")
	failureSound=love.audio.newSource("wrong.wav","static")

	background2=love.graphics.newImage("background2.png")

end

function otherGeometricPuzzle.draw()
	love.graphics.print("remaining shapes: "..number,sizeX/2+10,sizeY)
	--love.graphics.draw(background2,sizeX/2,0,0)

	for _,v in ipairs(shapes) do
		love.graphics.setColor(v.color)
		love.graphics.circle("line",v.xholder,v.yholder,radius,v.verts)
	end
	love.graphics.setColor(255,255,255)
	love.graphics.circle("fill",central.x,central.y,radius,central.verts)
end

function otherGeometricPuzzle.update(dt)
	central.x=love.mouse.getX()
	central.y=love.mouse.getY()
	for _,v in ipairs(shapes) do
		if between(central.x,v.xholder-radius,v.xholder+radius) and between(central.y,v.yholder-radius,v.yholder+radius) then
			if v.verts==central.verts then
				reward(1)
				love.audio.stop(combinedSound)
				love.audio.play(combinedSound)
				otherGeometricPuzzle.init(aux+0.25)
			end
		elseif distance(central.x,central.y,sizeX*0.75,sizeY/2)>dist then
			love.audio.stop(failureSound)
			love.audio.play(failureSound)
			love.mouse.setPosition(sizeX*0.75,sizeY/2)
			printC("chamando punish")
			punish(1)
			break
		end
	end
end

function otherGeometricPuzzle.mousepressed(key,x,y)

end

function otherGeometricPuzzle.mousereleased(key,x,y)

end

return otherGeometricPuzzle