require 'utils'
local gamera = require 'gamera'
policeCars = require 'policeCars'
doodleJump = require 'doodleJump'
geometricPuzzle = require 'geometricPuzzle'
otherGeomtricPuzzle=require 'geometricPuzzle2'


function love.load()

	console=false
	printC("Game started")

	sizeX,sizeY=love.graphics.getWidth(),love.graphics.getHeight()

	loadDoodleJump()
	loadOtherGeometricPuzzle()

	gameOverFont=love.graphics.newFont("font.ttf",30)
	defaultFont=love.graphics.newFont()


	score=0

	love.graphics.setBackgroundColor(0,0,0)

end

function love.draw()

	if not gameover then
		love.graphics.setFont(defaultFont)
		topCam:draw(currentGame.draw)
		botCam:draw(currentPuzzle.draw)
	else
		love.graphics.setFont(gameOverFont)
		love.graphics.printf("GAME OVER.\n You Scored "..score.." Points.\nPress R to restart.",0,sizeY/2,sizeX,"center")
	end

	if console then
		drawConsole()
	end
end

function love.update(dt)
	if not gameover then
		currentGame.update(dt)
		currentPuzzle.update(dt)
	end
end

function love.keypressed(key)
	if key=="c" then
		console=not console
	end
	if key=="r" then
		gameover=false
		currentPuzzle.init(4)
		currentGame.init()
	end
	if key=="escape" then
		love.event.quit()
	end
	currentGame.keypressed(key)
end

function love.mousepressed(x,y,button)
	currentPuzzle.mousepressed(x,y,button)
end

function love.mousereleased(x,y,button)
	currentPuzzle.mousereleased(x,y,button)
end

function loadDoodleJump()
	topCam=gamera.new(0, 0,sizeX/2,sizeY*10)
	topCam:setWindow(0,0,sizeX/2,sizeY)
	botCam=gamera.new(sizeX/2,0,sizeX/2,sizeY)
	botCam:setWindow(sizeX/2,0,sizeX/2,sizeY)
	currentGame=doodleJump
	currentGame.init()
end

function loadGeometricPuzzle()
	currentPuzzle=geometricPuzzle
	currentPuzzle.init(3)
end

function loadOtherGeometricPuzzle()
	currentPuzzle=otherGeometricPuzzle
	currentPuzzle.init(6)
end

function loadPoliceCars()
	topCam=gamera.new(0, 0,sizeX/2,sizeY)
	topCam:setWindow(0,0,sizeX/2,sizeY)
	botCam=gamera.new(sizeX/2,0,sizeX/2,sizeY)
	botCam:setWindow(sizeX/2,0,sizeX/2,sizeY)
	currentGame=policeCars
	currentGame.init()
end

function reward(n)
	printC("rewarding")
	currentGame.reward(n)
end

function punish(n)
	printC("punishing")
	currentGame.punish(n)
end